function ReplaceSpellEntities() {
    local ent = null;
    local spells = [];
    while(ent = Entities.FindByClassname(ent, "tf_spell_pickup")) {
        local tier = NetProps.GetPropInt(ent, "m_nTier");

        local spell_tier = Spells.SpellTiers[tier]
        local model = spell_tier["spellbook_model"];
        local offset = spell_tier["spellbook_model_offset"];

        local auto_mat = NetProps.GetPropBool(ent, "m_bAutoMaterialize");

        local spell_pickup = SpawnEntityFromTable("prop_dynamic", {
            "origin": ent.GetOrigin() + offset,
            "targetname": "spell_pickup",
            "model": model,
            "DefaultAnim": "idle",
            "vscripts": "sarex_spell_lib/spell_pickup.nut",
            "thinkfunction": "Think"
        });
        spell_pickup.GetScriptScope().Init(tier, auto_mat);
        spells.push(ent);
    }

    foreach (spell in spells) {
        spell.Kill();
    }
}